;Project Title: MadMedic's mirror system v 1.0 
;Author:     MadMedic
;Email:        MadMedic@rambler.ru
Type MMmirror
	Field Mesh,Surf,SubCamPivot,SubCam,MSize#
	Field TexSize,Tex,MaskTex
	Field UpdateTime,range#,LastUpdate
	Field VerticalScaling
End Type
Function MM_mirror_add(MSize#,TexSize,mask$,UpdateTime,range#,VerticalScaling)
m.MMmirror=New MMmirror
m\MSize=MSize
m\VerticalScaling=VerticalScaling
m\TexSize=TexSize
m\UpdateTime=UpdateTime
m\range#=range#
m\mesh=CreateMesh()
m\Surf=CreateSurface(m\mesh)
	v1=AddVertex(m\Surf,-0.5*MSize,0,-0.5*MSize,		0.15,		0.15)
	v2=AddVertex(m\Surf,-0.5*MSize,0,0.5*MSize,		0.15,		0.85)
	v3=AddVertex(m\Surf,0.5*MSize,0,-0.5*MSize,		0.85,	0.15)
	v4=AddVertex(m\Surf,0.5*MSize,0,0.5*MSize,		0.85,	0.85)
	AddTriangle(m\Surf,v1,v2,v3)
	AddTriangle(m\Surf,v3,v2,v4)

m\Tex=CreateTexture(m\TexSize,m\TexSize)



	
If FileSize(mask$)>1 Then
	m\MaskTex=LoadTexture(mask$,2+16+32)
	TransTex(m\MaskTex,0,0.7)
	EntityBlend m\mesh,1
	
	
	EntityTexture m\mesh,m\MaskTex,0,0
	EntityTexture m\mesh,m\Tex,0,1
Else
	EntityTexture m\mesh,m\Tex
EndIf
EntityFX m\mesh,1
m\SubCamPivot=CreatePivot(m\mesh)
m\SubCam=CreateCamera(m\SubCamPivot)
PositionEntity m\SubCam,0,-0.5*MSize*1.42,0,0
RotateEntity m\SubCam,-90,0,0
CameraViewport(m\SubCam,0,0,m\TexSize,m\TexSize)
CameraProjMode(m\SubCam,0)
CameraRange m\SubCam,0.001,1000



Return m\mesh
End Function
Function MM_mirror_update(cam)
For m.MMmirror=Each MMmirror
dist#=EntityDistance(m\mesh,cam)

If m\LastUpdate>0 Then
	If dist#>m\range# Then Goto SkipMirror
	If m\LastUpdate+m\UpdateTime>MilliSecs() Then Goto SkipMirror
	m\LastUpdate=MilliSecs()
Else
m\LastUpdate=MilliSecs()
EndIf
TFormPoint EntityX(cam,1),EntityY(cam,1),EntityZ(cam,1),0,m\mesh
tx#=TFormedX()
ty#=TFormedY()
tz#=TFormedZ()

yaw#=VectorYaw(tx,ty,tz)+180
Pitch#=VectorPitch(tx,ty,tz)*1+90
If Pitch#<0 Or Pitch>90 Then Goto SkipMirror

If m\VerticalScaling=1 Then ScaleEntity m\SubCam,1,1-Pitch#/240,1

TransTex(m\tex,yaw#*-1)
RotateEntity m\SubCamPivot,Pitch#,yaw#,0

	CameraProjMode cam,0
	CameraProjMode m\SubCam,1
	RenderWorld
		CopyRect 0,0,m\TexSize,m\TexSize,0,0,0,TextureBuffer( m\tex )
	CameraProjMode cam,1
	CameraProjMode m\SubCam,0

.SkipMirror
Next
End Function
Function MM_mirror_free()
For m.MMmirror=Each MMmirror
FreeTexture m\Tex
FreeTexture m\MaskTex
FreeEntity m\mesh
Delete m
Next
End Function 
Function TransTex(texture,angle#,scale#=1)
	ScaleTexture texture,scale,scale
	RotateTexture texture,angle#
	x#=Cos(angle)/scale/2
	y#=Sin(angle)/scale/2
	PositionTexture texture,(x-.5)-y,(y-.5)+x
End Function
