
AppTitle "Real Mirrors options..."

Print
Print "GRAPHICS CARD"
Print
Print "1. Low end card (ATI Rage or similar)"
Print "2. High end card (Geforce3 or similar)"
Print
Repeat
	flag = Input ("Graphics card level (1 or 2)? ")
Until (flag = 1) Or (flag = 2)

Select flag
	Case 1
		texflag = 0
	Case 2
		texflag = 256
End Select

Print
Print "TEXTURE -- NOTE: reduced if larger than screen!"
Print
Print "1. 128 x 128"
Print "2. 256 x 256 [Recommended for all]"
Print "3. 512 x 512"
Print "4. 1024 x 1024"
Print
Repeat
	flag = Input ("Texture size (1, 2, 4 or 4)? ")
Until (flag = 1) Or (flag = 2) Or (flag = 3) Or (flag = 4)

Select flag
	Case 1
		texsize = 128
	Case 2
		texsize = 256
	Case 3
		texsize = 512
	Case 4
		texsize = 1024
End Select

Print
Print "MIRROR SHAPE"
Print
Print "1. Square"
Print "2. Circular"
Print "3. Concentric"
Print "4. Weird"
Print
Repeat
	flag = Input ("Mirror shape (1, 2, 3 or 4)? ")
Until (flag = 1) Or (flag = 2) Or (flag = 3) Or (flag = 4)

Select flag
	Case 1
		mask$ = ""
		usingcircle = 1
	Case 2
		mask$ = "circle.bmp"
		usingcircle = 1
	Case 3
		mask$ = "conc.bmp"
		usingcircle = 1
	Case 4
		mask$ = "weird.bmp"
		usingcircle = 1
End Select

Print
Print "MIRROR SIZE"
Print
Repeat
	flag = Input ("Mirror size (1 to 10) -- (recommend 5)? ")
Until (flag > 0) And (flag <= 10)

Print
Print "CURSOR -- some cards can't mix 2D/3D quickly..."
Print
;If Lower (Input ("Disable mouse cursor (y/n)?")) = "y" Then mouse = False Else 
mouse = True

Function Diminish# (value#, amount#)
	If Abs (value) > Abs (amount)
		Return value - (amount * Sgn (value))
	EndIf
End Function

; -----------------------------------------------------------------------------
; Real Mirrors demo -- james @ hi-toro.com
; -----------------------------------------------------------------------------



; -----------------------------------------------------------------------------
; **** OI! Get DEBUG mode OFF!!!
; -----------------------------------------------------------------------------



; -----------------------------------------------------------------------------
; Include the mirror functions...
; -----------------------------------------------------------------------------

Include "includes/realmirrors.bb"

; -----------------------------------------------------------------------------
; SOME TWEAKABLE SETTINGS FOR THIS DEMO...
; -----------------------------------------------------------------------------

;usingcircle = 1		; Change to 1 for a circular mirror! Uses 'circle.bmp' as mask...
;texflag		= 0		; Change to 256 if you have a decent, modern-ish gfx card...
;texsize		= 256	; Change to suit your gfx card (this is OK on ATI Rage M1 w/ 8MB)...
mirrorsize#	= flag		; Obvious? :)

AppTitle "Real mirrors..."

; -----------------------------------------------------------------------------
; Gfx mode selection...
; -----------------------------------------------------------------------------

Include "includes/start.bb"

; -----------------------------------------------------------------------------
; Camera...
; -----------------------------------------------------------------------------

cam = CreateCamera ()
CameraRange cam, 0.1, 1000
CameraClsColor cam, 64, 64, 96
MoveEntity cam, 0, 4, -10

grav# = 0.005

; -----------------------------------------------------------------------------
; Ball...
; -----------------------------------------------------------------------------

logo = LoadTexture ("gfx/b3dlogo.jpg")
ball = CreateSphere (16, cam)
EntityTexture ball, logo
ScaleMesh ball, 0.25, 0.25, 0.25
MoveEntity ball, 0, -0.5, 5

; -----------------------------------------------------------------------------
; Grassy plane...
; -----------------------------------------------------------------------------

plane = CreatePlane ()
grass = LoadTexture ("gfx/grass.bmp")
EntityTexture plane, grass

; -----------------------------------------------------------------------------
; A mirror, using the same RGB values as our main camera's
; CameraClsColor, defined above...
; -----------------------------------------------------------------------------

m.Mirror = CreateRealMirror (mirrorsize, texsize, texflag, 64, 64, 96, 100, 1000, usingcircle)
PositionEntity MirrorMesh (m), 0, 2 + (mirrorsize / 2), 5

; -----------------------------------------------------------------------------
; Colour the mirror's backing panel (appears at 'fade out' range...
; -----------------------------------------------------------------------------

EntityColor MirrorBacking (m), 16, 16, 64

; -----------------------------------------------------------------------------
; Applying an example shape mask to the mirror (see tweakable settings)...
; -----------------------------------------------------------------------------

If usingcircle
	ApplyMirrorMask (m, mask$)
EndIf

; -----------------------------------------------------------------------------
; A light for aesthetics...
; -----------------------------------------------------------------------------

light = CreateLight (1)
;sun = LoadSprite ("gfx/point.bmp", 0, light)
;ScaleSprite sun, 10, 10

MoveEntity light, -250, 100, -50
PointEntity light, MirrorMesh (m)

tree = CreateSphere ()
HideEntity tree

Type Frog
	Field sprite
	Field ys#
End Type

For a = 1 To 200
	f.Frog = New Frog
	f\sprite = CopyEntity (tree)
	ScaleEntity f\sprite, Rnd (0.125, 0.5), Rnd (0.125, 0.5), Rnd (0.125, 0.5)
	TurnEntity f\sprite, 0, Rnd (270, 90), 0
	MoveEntity f\sprite, 0, Rnd (2, 100), Rnd (5, 40)
	EntityColor f\sprite, Rnd (255), Rnd (255), Rnd (255)
Next

SetFont LoadFont ("arial", 12, 1)
MoveMouse GraphicsWidth () / 2, GraphicsHeight () / 2

AmbientLight 150, 150, 150

mirror = MirrorMesh (m)
EntityPickMode mirror, 2

HidePointer

gameFPS = 50

framePeriod = 1000 / gameFPS 
frameTime = MilliSecs () - framePeriod 

Repeat

    ; -------------------------------------------------------------- 
    ; Frame limiting 

    ; -------------------------------------------------------------- 

    Repeat 
        frameElapsed = MilliSecs () - frameTime 
    Until frameElapsed 

    frameTicks = frameElapsed / framePeriod 
     
    frameTween# = Float (frameElapsed Mod framePeriod) / Float (framePeriod) 

    ; -------------------------------------------------------------- 
    ; Update game and world state 
    ; -------------------------------------------------------------- 
     
    For frameLimit = 1 To frameTicks 
     
        If frameLimit = frameTicks Then CaptureWorld 
        frameTime = frameTime + framePeriod 
         
        Gosub UpdateGame

        UpdateWorld 
             
    Next 

	; -------------------------------------------------------------------------
	; Update the mirror...
	; -------------------------------------------------------------------------

	UpdateMirror (cam, m)
	RenderWorld frameTween

	If mouse
		Line mx - 3, my, mx + 4, my
		Line mx, my - 3, mx, my + 4
	EndIf
	
	Flip

	If KeyHit (28) Then SaveBuffer FrontBuffer (), "grab.bmp" ; ENTER grabs screenshot...
	
Until KeyHit (1)

End

.UpdateGame

	TurnEntity ball, 1, 0.5, 2

	mx = MouseX ()
	my = MouseY ()
	
	If MouseDown (1)
		If CameraPick (cam, mx, my) = mirror
			If lifted = True
				CameraProject cam, EntityX (mirror, 1), EntityY (mirror, 1), EntityZ (mirror, 1)
				MoveMouse ProjectedX (), ProjectedY ()
				lifted = False
			EndIf
			dist# = EntityDistance (mirror, ball)
			TurnEntity mirror, -MouseYSpeed (), 0, 0
			TurnEntity mirror, 0, MouseXSpeed (), 0, 1
		EndIf
	Else
		lifted = True
		PointEntity mirror, ball
		TurnEntity mirror, 0, 180, 0
	EndIf

	If KeyDown (203) And yawspeed# < 2 Then yawspeed = yawspeed + 0.05 ; TurnEntity cam, 0, 1, 0, 1
	If KeyDown (205) And yawspeed > -2 Then yawspeed = yawspeed - 0.05 ; TurnEntity cam, 0, -1, 0, 1
	If KeyDown (200)  And pitchspeed# < 2 Then pitchspeed = pitchspeed + 0.05 ; TurnEntity cam, 1, 0, 0
	If KeyDown (208)  And pitchspeed > -2 Then pitchspeed = pitchspeed - 0.05 ; TurnEntity cam, -1, 0, 0
	
	If KeyDown (30) Then speed# = speed + 0.01
	If KeyDown (44) Then speed# = speed - 0.01

	TurnEntity cam, 0, yawspeed, 0, 1
	TurnEntity cam, pitchspeed, 0, 0
	
	yawspeed = Diminish (yawspeed, 0.02)
	pitchspeed = Diminish (pitchspeed, 0.02)
	speed = Diminish (speed, 0.005)
	MoveEntity cam, 0, 0, speed
	
	For f.Frog = Each Frog
		f\ys = f\ys - grav
		If EntityY (f\sprite) < 0.25
			f\ys = -f\ys
		EndIf
		TurnEntity f\sprite, 1, 2, 4
		TranslateEntity f\sprite, 0, f\ys, 0
	Next
	
;	If EntityZ (cam, 1) > 3
;		PositionEntity cam, EntityX (cam, 1), EntityY (cam, 1), 3, 1
;		speed = 0
;	EndIf
	
	PositionEntity ball, 0, 0, 2 + (speed * 5)

Return